/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef CLIPBOARD_H
#define CLIPBOARD_H

#include "worksheet.h"
#include "graph.h"
#include "draw.h"
#include "button.h"
#include "cell.h"

struct _Clipboard
  {
    Cell **cells;
    int ncells;
    Graph **graphs;
    int ngraphs;
    Drawing **drawings;
    int ndrawings;
    Button **buttons;
    int nbuttons;
    int r1, r2, c1, c2;
  };

typedef struct _Clipboard Clipboard;

extern Clipboard *clipboard;

extern int copy_clipboard (Selection * sel);
extern int paste_clipboard (Selection * sel);
extern int paste_special_clipboard (Selection * sel, int all, int formula, int value, int format, int none, int add, int sub, int div, int mul, int trans);
extern int cut_clipboard (Selection * sel);

extern Clipboard *newclipboard ();
extern int freeclipboard (Clipboard * clipboard);
extern int clear_clipboard (Clipboard * clipboard);


#endif
