/********************************************************************
This file is part of the abs 0.907 distribution.  abs is a spreadsheet
with graphical user interface.

Copyright (C) 1998-2001  Andr Bertin (Andre.Bertin@ping.be) 

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version if in the same spirit as version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Concact: abs@pi.be
         http://home.pi.be/bertin/abs.shtml

*********************************************************************/


























#ifndef CURSOR_H
#define CURSOR_H

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>

#define ARROW 0
#define HAND 1
#define CROSS 2
#define BOTTOM_LEFT 3
#define BOTTOM_RIGHT 4
#define TOP_RIGHT 5
#define TOP_LEFT 6
#define TOP_SIDE 7
#define BOTTOM_SIDE 8
#define LEFT_SIDE 9
#define RIGHT_SIDE 10
#define EXTEND_SELECT 11
#define EDIT_DRA 12
#define SPRAY 13
#define PENCIL 14
#define CMOVE 15

typedef enum
  {
    ctARROW, ctHAND, ctBOTTOM_RIGHT
  }
cursor_type;

extern int setcursortype (cursor_type type);

extern int getcursortype ();

extern void TurnOffCross (Widget w);
extern void TurnOffCursor (Widget w);
extern void TurnOffMove (Widget w);
extern void TurnOnBottomSide (Widget w);
extern void TurnOnRightSide (Widget w);
extern void TurnOnLeftSide (Widget w);
extern void TurnOnTopSide (Widget w);
extern void TurnOnTopRight (Widget w);
extern void TurnOnTopLeft (Widget w);
extern void TurnOnBottomRight (Widget w);
extern void TurnOnBottomLeft (Widget w);
extern void TurnOnHand (Widget w);
extern void TurnOnMove (Widget w);
extern void TurnOnPencil (Widget w);
extern void TurnOnSpray (Widget w);
extern void TurnOnCross (Widget w);
extern int TurnOnLimitCursor (Widget draw, int xa, int ya, int xb, int yb, int x, int y);

#endif 
